#!/usr/bin/python
__author__ = 'Piotr Matuszczyk <piotr.matuszczyk@sap.com>'

import yaml, json

def parse_vars_file(vars_file_location):
  with open(vars_file_location, 'r') as varsfile:
    cfg = yaml.load(varsfile)
  return cfg

def findNetworkAddress(resourcejson):
  result = []
  def decodeJson(jdict):
    try: 
      result.append(jdict['NETWORK_ADDRESS'])
    except KeyError:
      pass
    return jdict
  json.loads(resourcejson, object_hook=decodeJson)
  return result